/*
 * Unix SMB/CIFS implementation.
 * client auto-generated by pidl. DO NOT MODIFY!
 */

#include "includes.h"
#include "../librpc/gen_ndr/cli_browser.h"

NTSTATUS rpccli_BrowserrServerEnum(struct rpc_pipe_client *cli,
				   TALLOC_CTX *mem_ctx)
{
	struct BrowserrServerEnum r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserrServerEnum, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRSERVERENUM,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserrServerEnum, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_BrowserrDebugCall(struct rpc_pipe_client *cli,
				  TALLOC_CTX *mem_ctx)
{
	struct BrowserrDebugCall r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserrDebugCall, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRDEBUGCALL,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserrDebugCall, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_BrowserrQueryOtherDomains(struct rpc_pipe_client *cli,
					  TALLOC_CTX *mem_ctx,
					  const char *server_unc /* [in] [unique,charset(UTF16)] */,
					  struct BrowserrSrvInfo *info /* [in,out] [ref] */,
					  uint32_t *total_entries /* [out] [ref] */,
					  WERROR *werror)
{
	struct BrowserrQueryOtherDomains r;
	NTSTATUS status;

	/* In parameters */
	r.in.server_unc = server_unc;
	r.in.info = info;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserrQueryOtherDomains, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRQUERYOTHERDOMAINS,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserrQueryOtherDomains, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*info = *r.out.info;
	*total_entries = *r.out.total_entries;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_BrowserrResetNetlogonState(struct rpc_pipe_client *cli,
					   TALLOC_CTX *mem_ctx)
{
	struct BrowserrResetNetlogonState r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserrResetNetlogonState, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRRESETNETLOGONSTATE,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserrResetNetlogonState, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_BrowserrDebugTrace(struct rpc_pipe_client *cli,
				   TALLOC_CTX *mem_ctx)
{
	struct BrowserrDebugTrace r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserrDebugTrace, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRDEBUGTRACE,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserrDebugTrace, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_BrowserrQueryStatistics(struct rpc_pipe_client *cli,
					TALLOC_CTX *mem_ctx)
{
	struct BrowserrQueryStatistics r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserrQueryStatistics, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRQUERYSTATISTICS,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserrQueryStatistics, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_BrowserResetStatistics(struct rpc_pipe_client *cli,
				       TALLOC_CTX *mem_ctx)
{
	struct BrowserResetStatistics r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserResetStatistics, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRESETSTATISTICS,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserResetStatistics, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_NetrBrowserStatisticsClear(struct rpc_pipe_client *cli,
					   TALLOC_CTX *mem_ctx)
{
	struct NetrBrowserStatisticsClear r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(NetrBrowserStatisticsClear, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_NETRBROWSERSTATISTICSCLEAR,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(NetrBrowserStatisticsClear, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_NetrBrowserStatisticsGet(struct rpc_pipe_client *cli,
					 TALLOC_CTX *mem_ctx)
{
	struct NetrBrowserStatisticsGet r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(NetrBrowserStatisticsGet, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_NETRBROWSERSTATISTICSGET,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(NetrBrowserStatisticsGet, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_BrowserrSetNetlogonState(struct rpc_pipe_client *cli,
					 TALLOC_CTX *mem_ctx)
{
	struct BrowserrSetNetlogonState r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserrSetNetlogonState, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRSETNETLOGONSTATE,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserrSetNetlogonState, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_BrowserrQueryEmulatedDomains(struct rpc_pipe_client *cli,
					     TALLOC_CTX *mem_ctx)
{
	struct BrowserrQueryEmulatedDomains r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserrQueryEmulatedDomains, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRQUERYEMULATEDDOMAINS,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserrQueryEmulatedDomains, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_BrowserrServerEnumEx(struct rpc_pipe_client *cli,
				     TALLOC_CTX *mem_ctx)
{
	struct BrowserrServerEnumEx r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(BrowserrServerEnumEx, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_browser,
				NDR_BROWSERRSERVERENUMEX,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(BrowserrServerEnumEx, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	return NT_STATUS_OK;
}

