/*
 * Unix SMB/CIFS implementation.
 * client auto-generated by pidl. DO NOT MODIFY!
 */

#include "includes.h"
#include "../librpc/gen_ndr/cli_mgmt.h"

NTSTATUS rpccli_mgmt_inq_if_ids(struct rpc_pipe_client *cli,
				TALLOC_CTX *mem_ctx,
				struct rpc_if_id_vector_t **if_id_vector /* [out] [ref] */,
				WERROR *werror)
{
	struct mgmt_inq_if_ids r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_inq_if_ids, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_mgmt,
				NDR_MGMT_INQ_IF_IDS,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_inq_if_ids, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*if_id_vector = *r.out.if_id_vector;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_mgmt_inq_stats(struct rpc_pipe_client *cli,
			       TALLOC_CTX *mem_ctx,
			       uint32_t max_count /* [in]  */,
			       uint32_t unknown /* [in]  */,
			       struct mgmt_statistics *statistics /* [out] [ref] */,
			       WERROR *werror)
{
	struct mgmt_inq_stats r;
	NTSTATUS status;

	/* In parameters */
	r.in.max_count = max_count;
	r.in.unknown = unknown;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_inq_stats, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_mgmt,
				NDR_MGMT_INQ_STATS,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_inq_stats, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*statistics = *r.out.statistics;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_mgmt_is_server_listening(struct rpc_pipe_client *cli,
					 TALLOC_CTX *mem_ctx,
					 uint32_t *status /* [out] [ref] */)
{
	struct mgmt_is_server_listening r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_is_server_listening, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_mgmt,
				NDR_MGMT_IS_SERVER_LISTENING,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_is_server_listening, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*status = *r.out.status;

	/* Return result */
	return NT_STATUS_OK;
}

NTSTATUS rpccli_mgmt_stop_server_listening(struct rpc_pipe_client *cli,
					   TALLOC_CTX *mem_ctx,
					   WERROR *werror)
{
	struct mgmt_stop_server_listening r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_stop_server_listening, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_mgmt,
				NDR_MGMT_STOP_SERVER_LISTENING,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_stop_server_listening, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_mgmt_inq_princ_name(struct rpc_pipe_client *cli,
				    TALLOC_CTX *mem_ctx,
				    uint32_t authn_proto /* [in]  */,
				    uint32_t princ_name_size /* [in]  */,
				    const char *princ_name /* [out] [charset(DOS)] */,
				    WERROR *werror)
{
	struct mgmt_inq_princ_name r;
	NTSTATUS status;

	/* In parameters */
	r.in.authn_proto = authn_proto;
	r.in.princ_name_size = princ_name_size;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_inq_princ_name, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_mgmt,
				NDR_MGMT_INQ_PRINC_NAME,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_inq_princ_name, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	memcpy(CONST_DISCARD(char *, princ_name), r.out.princ_name,  * sizeof(*princ_name));

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

