/*
 * Unix SMB/CIFS implementation.
 * client auto-generated by pidl. DO NOT MODIFY!
 */

#include "includes.h"
#include "../librpc/gen_ndr/cli_oxidresolver.h"

NTSTATUS rpccli_ResolveOxid(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    uint64_t pOxid /* [in]  */,
			    uint16_t cRequestedProtseqs /* [in]  */,
			    uint16_t *arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
			    struct DUALSTRINGARRAY **ppdsaOxidBindings /* [out] [ref] */,
			    struct GUID *pipidRemUnknown /* [out] [ref] */,
			    uint32_t *pAuthnHint /* [out] [ref] */,
			    WERROR *werror)
{
	struct ResolveOxid r;
	NTSTATUS status;

	/* In parameters */
	r.in.pOxid = pOxid;
	r.in.cRequestedProtseqs = cRequestedProtseqs;
	r.in.arRequestedProtseqs = arRequestedProtseqs;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(ResolveOxid, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_RESOLVEOXID,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(ResolveOxid, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*ppdsaOxidBindings = *r.out.ppdsaOxidBindings;
	*pipidRemUnknown = *r.out.pipidRemUnknown;
	*pAuthnHint = *r.out.pAuthnHint;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_SimplePing(struct rpc_pipe_client *cli,
			   TALLOC_CTX *mem_ctx,
			   uint64_t *SetId /* [in] [ref] */,
			   WERROR *werror)
{
	struct SimplePing r;
	NTSTATUS status;

	/* In parameters */
	r.in.SetId = SetId;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(SimplePing, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_SIMPLEPING,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(SimplePing, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_ComplexPing(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    uint64_t *SetId /* [in,out] [ref] */,
			    uint16_t SequenceNum /* [in]  */,
			    uint16_t cAddToSet /* [in]  */,
			    uint16_t cDelFromSet /* [in]  */,
			    struct GUID *AddToSet /* [in] [size_is(cAddToSet)] */,
			    struct GUID *DelFromSet /* [in] [size_is(cDelFromSet)] */,
			    uint16_t *PingBackoffFactor /* [out] [ref] */,
			    WERROR *werror)
{
	struct ComplexPing r;
	NTSTATUS status;

	/* In parameters */
	r.in.SetId = SetId;
	r.in.SequenceNum = SequenceNum;
	r.in.cAddToSet = cAddToSet;
	r.in.cDelFromSet = cDelFromSet;
	r.in.AddToSet = AddToSet;
	r.in.DelFromSet = DelFromSet;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(ComplexPing, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_COMPLEXPING,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(ComplexPing, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*SetId = *r.out.SetId;
	*PingBackoffFactor = *r.out.PingBackoffFactor;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_ServerAlive(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    WERROR *werror)
{
	struct ServerAlive r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(ServerAlive, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_SERVERALIVE,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(ServerAlive, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_ResolveOxid2(struct rpc_pipe_client *cli,
			     TALLOC_CTX *mem_ctx,
			     uint64_t pOxid /* [in]  */,
			     uint16_t cRequestedProtseqs /* [in]  */,
			     uint16_t *arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
			     struct DUALSTRINGARRAY **pdsaOxidBindings /* [out] [ref] */,
			     struct GUID *ipidRemUnknown /* [out] [ref] */,
			     uint32_t *AuthnHint /* [out] [ref] */,
			     struct COMVERSION *ComVersion /* [out] [ref] */,
			     WERROR *werror)
{
	struct ResolveOxid2 r;
	NTSTATUS status;

	/* In parameters */
	r.in.pOxid = pOxid;
	r.in.cRequestedProtseqs = cRequestedProtseqs;
	r.in.arRequestedProtseqs = arRequestedProtseqs;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(ResolveOxid2, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_RESOLVEOXID2,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(ResolveOxid2, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*pdsaOxidBindings = *r.out.pdsaOxidBindings;
	*ipidRemUnknown = *r.out.ipidRemUnknown;
	*AuthnHint = *r.out.AuthnHint;
	*ComVersion = *r.out.ComVersion;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_ServerAlive2(struct rpc_pipe_client *cli,
			     TALLOC_CTX *mem_ctx,
			     struct COMINFO *info /* [out] [ref] */,
			     struct DUALSTRINGARRAY *dualstring /* [out] [ref] */,
			     uint8_t *unknown2 /* [out] [ref] */,
			     uint8_t *unknown3 /* [out] [ref] */,
			     uint8_t *unknown4 /* [out] [ref] */,
			     WERROR *werror)
{
	struct ServerAlive2 r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(ServerAlive2, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_IOXIDResolver,
				NDR_SERVERALIVE2,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(ServerAlive2, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*info = *r.out.info;
	*dualstring = *r.out.dualstring;
	*unknown2 = *r.out.unknown2;
	*unknown3 = *r.out.unknown3;
	*unknown4 = *r.out.unknown4;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

