#include "../librpc/gen_ndr/ndr_oxidresolver.h"
#ifndef __CLI_IOXIDRESOLVER__
#define __CLI_IOXIDRESOLVER__
NTSTATUS rpccli_ResolveOxid(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    uint64_t pOxid /* [in]  */,
			    uint16_t cRequestedProtseqs /* [in]  */,
			    uint16_t *arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
			    struct DUALSTRINGARRAY **ppdsaOxidBindings /* [out] [ref] */,
			    struct GUID *pipidRemUnknown /* [out] [ref] */,
			    uint32_t *pAuthnHint /* [out] [ref] */,
			    WERROR *werror);
NTSTATUS rpccli_SimplePing(struct rpc_pipe_client *cli,
			   TALLOC_CTX *mem_ctx,
			   uint64_t *SetId /* [in] [ref] */,
			   WERROR *werror);
NTSTATUS rpccli_ComplexPing(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    uint64_t *SetId /* [in,out] [ref] */,
			    uint16_t SequenceNum /* [in]  */,
			    uint16_t cAddToSet /* [in]  */,
			    uint16_t cDelFromSet /* [in]  */,
			    struct GUID *AddToSet /* [in] [size_is(cAddToSet)] */,
			    struct GUID *DelFromSet /* [in] [size_is(cDelFromSet)] */,
			    uint16_t *PingBackoffFactor /* [out] [ref] */,
			    WERROR *werror);
NTSTATUS rpccli_ServerAlive(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    WERROR *werror);
NTSTATUS rpccli_ResolveOxid2(struct rpc_pipe_client *cli,
			     TALLOC_CTX *mem_ctx,
			     uint64_t pOxid /* [in]  */,
			     uint16_t cRequestedProtseqs /* [in]  */,
			     uint16_t *arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
			     struct DUALSTRINGARRAY **pdsaOxidBindings /* [out] [ref] */,
			     struct GUID *ipidRemUnknown /* [out] [ref] */,
			     uint32_t *AuthnHint /* [out] [ref] */,
			     struct COMVERSION *ComVersion /* [out] [ref] */,
			     WERROR *werror);
NTSTATUS rpccli_ServerAlive2(struct rpc_pipe_client *cli,
			     TALLOC_CTX *mem_ctx,
			     struct COMINFO *info /* [out] [ref] */,
			     struct DUALSTRINGARRAY *dualstring /* [out] [ref] */,
			     uint8_t *unknown2 /* [out] [ref] */,
			     uint8_t *unknown3 /* [out] [ref] */,
			     uint8_t *unknown4 /* [out] [ref] */,
			     WERROR *werror);
#endif /* __CLI_IOXIDRESOLVER__ */
