/*
 * Unix SMB/CIFS implementation.
 * client auto-generated by pidl. DO NOT MODIFY!
 */

#include "includes.h"
#include "../librpc/gen_ndr/cli_rot.h"

NTSTATUS rpccli_rot_add(struct rpc_pipe_client *cli,
			TALLOC_CTX *mem_ctx,
			uint32_t flags /* [in]  */,
			struct MInterfacePointer *unk /* [in] [ref] */,
			struct MInterfacePointer *moniker /* [in] [ref] */,
			uint32_t *rotid /* [out] [ref] */,
			WERROR *werror)
{
	struct rot_add r;
	NTSTATUS status;

	/* In parameters */
	r.in.flags = flags;
	r.in.unk = unk;
	r.in.moniker = moniker;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(rot_add, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_rot,
				NDR_ROT_ADD,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(rot_add, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*rotid = *r.out.rotid;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_rot_remove(struct rpc_pipe_client *cli,
			   TALLOC_CTX *mem_ctx,
			   uint32_t rotid /* [in]  */,
			   WERROR *werror)
{
	struct rot_remove r;
	NTSTATUS status;

	/* In parameters */
	r.in.rotid = rotid;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(rot_remove, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_rot,
				NDR_ROT_REMOVE,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(rot_remove, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_rot_is_listed(struct rpc_pipe_client *cli,
			      TALLOC_CTX *mem_ctx,
			      struct MInterfacePointer *moniker /* [in] [ref] */,
			      WERROR *werror)
{
	struct rot_is_listed r;
	NTSTATUS status;

	/* In parameters */
	r.in.moniker = moniker;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(rot_is_listed, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_rot,
				NDR_ROT_IS_LISTED,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(rot_is_listed, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_rot_get_interface_pointer(struct rpc_pipe_client *cli,
					  TALLOC_CTX *mem_ctx,
					  struct MInterfacePointer *moniker /* [in] [ref] */,
					  struct MInterfacePointer *ip /* [out] [ref] */,
					  WERROR *werror)
{
	struct rot_get_interface_pointer r;
	NTSTATUS status;

	/* In parameters */
	r.in.moniker = moniker;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(rot_get_interface_pointer, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_rot,
				NDR_ROT_GET_INTERFACE_POINTER,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(rot_get_interface_pointer, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*ip = *r.out.ip;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_rot_set_modification_time(struct rpc_pipe_client *cli,
					  TALLOC_CTX *mem_ctx,
					  uint32_t rotid /* [in]  */,
					  NTTIME *t /* [in] [ref] */,
					  WERROR *werror)
{
	struct rot_set_modification_time r;
	NTSTATUS status;

	/* In parameters */
	r.in.rotid = rotid;
	r.in.t = t;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(rot_set_modification_time, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_rot,
				NDR_ROT_SET_MODIFICATION_TIME,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(rot_set_modification_time, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_rot_get_modification_time(struct rpc_pipe_client *cli,
					  TALLOC_CTX *mem_ctx,
					  struct MInterfacePointer *moniker /* [in] [ref] */,
					  NTTIME *t /* [out] [ref] */,
					  WERROR *werror)
{
	struct rot_get_modification_time r;
	NTSTATUS status;

	/* In parameters */
	r.in.moniker = moniker;

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(rot_get_modification_time, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_rot,
				NDR_ROT_GET_MODIFICATION_TIME,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(rot_get_modification_time, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*t = *r.out.t;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

NTSTATUS rpccli_rot_enum(struct rpc_pipe_client *cli,
			 TALLOC_CTX *mem_ctx,
			 struct MInterfacePointer *EnumMoniker /* [out] [ref] */,
			 WERROR *werror)
{
	struct rot_enum r;
	NTSTATUS status;

	/* In parameters */

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(rot_enum, &r);
	}

	status = cli->dispatch(cli,
				mem_ctx,
				&ndr_table_rot,
				NDR_ROT_ENUM,
				&r);

	if (!NT_STATUS_IS_OK(status)) {
		return status;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(rot_enum, &r);
	}

	if (NT_STATUS_IS_ERR(status)) {
		return status;
	}

	/* Return variables */
	*EnumMoniker = *r.out.EnumMoniker;

	/* Return result */
	if (werror) {
		*werror = r.out.result;
	}

	return werror_to_ntstatus(r.out.result);
}

